package
{
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
    import flash.text.TextField;
	import flash.text.TextFormat;
	
	import com.nativeExtensions.saf.Document;
	import com.nativeExtensions.saf.DocumentEvent;
	
    public class Main extends Sprite
	{
        private var textField:TextField = new TextField();
		private var document:Document;

        public function Main()
		{		
			this.addEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
        }
		
		private function addedToStageHandler(event:Event):void
        {
            this.removeEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
            textField.border = true;
			textField.type = "input";
			textField.wordWrap = true;
			textField.multiline = true;
			textField.width = 800;
			textField.height = 800;

            var format:TextFormat = new TextFormat();
            format.size = 30;

            textField.defaultTextFormat = format;
            this.addChild(textField);
			
			var sprite:Sprite = new Sprite();
			sprite.graphics.beginFill(0xFF0000);
			sprite.graphics.drawRect( 0, 0, 200, 200);
			sprite.graphics.endFill();
			sprite.y = textField.height + 20;
			sprite.addEventListener(MouseEvent.CLICK, mouseClickReadHandler);
			this.addChild( sprite );
			var textField1:TextField = new TextField();
			textField1.defaultTextFormat = format;
			textField1.mouseEnabled = false;
			textField1.text = "read";
			textField1.y = sprite.y;
			this.addChild( textField1 );
			
			var sprite2:Sprite = new Sprite();
			sprite2.graphics.beginFill(0x00FF00);
			sprite2.graphics.drawRect( 0, 0, 200, 200);
			sprite2.graphics.endFill();
			sprite2.x = sprite.x + sprite.width + 20;
			sprite2.y = sprite.y;
			sprite2.addEventListener(MouseEvent.CLICK, mouseClickCreateHandler);
			this.addChild( sprite2 );
			var textField2:TextField = new TextField();
			textField2.defaultTextFormat = format;
			textField2.mouseEnabled = false;
			textField2.text = "create";
			textField2.x = sprite2.x;
			textField2.y = sprite2.y;
			this.addChild( textField2 );
			
			var sprite3:Sprite = new Sprite();
			sprite3.graphics.beginFill(0x0000FF);
			sprite3.graphics.drawRect( 0, 0, 200, 200);
			sprite3.graphics.endFill();
			sprite3.y = sprite.y + sprite.height + 20;
			sprite3.addEventListener(MouseEvent.CLICK, mouseClickDeleteHandler);
			this.addChild( sprite3 );
			var textField3:TextField = new TextField();
			textField3.defaultTextFormat = format;
			textField3.mouseEnabled = false;
			textField3.text = "delete";
			textField3.y = sprite3.y;
			this.addChild( textField3 );
			
			var sprite4:Sprite = new Sprite();
			sprite4.graphics.beginFill(0xFFFF00);
			sprite4.graphics.drawRect( 0, 0, 200, 200);
			sprite4.graphics.endFill();
			sprite4.x = sprite3.x + sprite3.width + 20;
			sprite4.y = sprite3.y;
			sprite4.addEventListener(MouseEvent.CLICK, mouseClickEditHandler);
			this.addChild( sprite4 );
			var textField4:TextField = new TextField();
			textField4.defaultTextFormat = format;
			textField4.mouseEnabled = false;
			textField4.text = "edit";
			textField4.x = sprite4.x;
			textField4.y = sprite4.y;
			this.addChild( textField4 );
			
			document = new Document();
			document.addEventListener(DocumentEvent.READ, onRead);
			//document.addEventListener(DocumentEvent.READ_BYTES, onRead);
			document.addEventListener(DocumentEvent.DELETE, onDelete);
			document.addEventListener(DocumentEvent.EDIT, onEdit);
			document.addEventListener(DocumentEvent.CANCEL, onCancel);
			document.addEventListener(IOErrorEvent.IO_ERROR, onError);
		}
		
		private function mouseClickReadHandler(event : MouseEvent) : void
		{
			//document.getUri("application/pdf");
			document.read("text/*");
			//document.readBytes("image/*");
		}
		
		private function mouseClickCreateHandler(event : MouseEvent) : void
		{
			document.create("testFile.txt", "content", "text/plain");
			//document.createBytes("test.png", byteArray, "image/*");
		}
		
		private function mouseClickDeleteHandler(event : MouseEvent) : void
		{
			document.deleteFile("text/plain");
		}
		
		private function mouseClickEditHandler(event : MouseEvent) : void
		{
			document.edit("content\nreplace", "text/plain");
			//document.editBytes(byteArray, "image/*");
		}
		
		private function onRead(event:DocumentEvent):void
		{
			trace( event.uri );
			textField.appendText( event.content + "\n" );
			//trace( event.bytes );
		}
		
		private function onDelete(event:DocumentEvent):void
		{
			trace( event.uri );
		}
		
		private function onEdit(event:DocumentEvent):void
		{
			trace( event.uri );
		}
		
		private function onCancel(event:DocumentEvent):void
		{
			trace( "cancel" );
		}
		
		private function onError(event:IOErrorEvent):void
		{
			textField.appendText( event.text + "\n" );
		}
    }
}